
' UnAlien! v1.0
' (C) 2008 Innova and Kristopher Windsor

#include once "fbgfx.bi"
#include once "fmod.bi"

#define backgroundalpha alpha, 150
#define masteralpha trans
#define menualpha alpha, 50

#macro cleanup(data, data_total)
  'new macro should have been created a long time ago
  Scope
    Dim As Integer a
    
    a = 1
    While a <= data_total
      If Data(a).core.killme Then
        Swap Data(a), Data(data_total)
        data_total -= 1
      Else
        a += 1
      End If
    Wend
  End Scope
#endmacro

#macro cleanup_clip(data, data_total, data_graphic)
  For a As Integer = 1 To data_total
    With Data(a)
      If .core.p.x + (data_graphic -> Width) - 1 < game.cam Then .core.killme = true
    End With
  Next a
#endmacro

'from yetifoot and mysoft (I think my bounds checking may be off 1 pixel, or my computer was crashing from something else... which is likely since this is Vista...)
'#define point2(x, y, source) cptr(uinteger ptr, cptr(any ptr, (source)) + sizeof(fb.image) + ((y) * (source) -> pitch))[(x)]
#define point2 point

Const screenx = 800, screeny = 480
Const true = -1, false = 0
Const pi = Atn(1) * 4

Const alien_max = 64, beamup_max = 32, bomb_max = 32, bombglow_max = 8, bonus_max = 256, boss_max = 2, bubble_max = 256, bubblemaker_max = 16
Const damage_max = 128, flame_max = 32, highscore_max = 8, message_max = 8, missile_max = 1024, obstacle_max = 256
Const obstacle_graphic_max = 32, particle_max = 128, portal_max = 8, option_max = 8, sound_music_max = 8

Enum bonus_enum
  energy = 1
  gem
  health
  missile
  total = missile
End Enum

Type coord_type
  As Double x, y
End Type

Type core_type
  As coord_type p
  
  As Integer killme
End Type

Type alien_type
  As Double yv
  As core_type core
End Type

Type beamup_type
  As core_type core
End Type

Type bomb_type
  As core_type core
End Type

Type bombglow_type
  As Integer ttl
  As core_type core
End Type

Type bonus_type
  As bonus_enum btype
  As core_type core
End Type

Type boss_type
  As Integer hp 'hit points
  As Double yv
  As core_type core
End Type

Type bubble_type
  As coord_type v
  As core_type core
End Type

Type bubblemaker_type
  As core_type core
End Type

Type damage_type
  As Integer ttl 'time to live
  As core_type core
End Type

Type flame_type
  As core_type core
End Type

Type highscore_type
  As String player
  As Integer score
End Type

Type message_type
  As String text
  As core_type core
End Type

Type missile_type
  As Double xv
  As core_type core
End Type

Type obstacle_type
  As Integer index, falling
  As Double yv
  As core_type core
End Type

Type obstacle_graphic_type
  As fb.image Ptr image
  As String title
End Type

Type particle_type
  Const speed = 2
  
  As Double distance
  As Integer ttl 'time to live
  As core_type core
End Type

Type player_type
  Const history_max = 10
  
  As coord_type v
  As Integer bonus_energy, bonus_missile, bonus_health, bonus_score
  As Double history(1 To history_max)
  As Integer hit
  As core_type core
End Type

Type option_type
  As String options(1 To option_max)
  As Integer total
End Type

Type portal_type
  As core_type core
End Type

Type progress_type
  As Integer level, score
End Type

Type game_type
  Const level_max = 17
  
  As Integer quit, won, lost
  As Integer t 'time
  As Integer frame
  As Double cam
  As String key
End Type

Dim Shared As Integer alien_total, beamup_total, bomb_total, bombglow_total, bonus_total, boss_total, bubble_total, bubblemaker_total, damage_total
Dim Shared As Integer flame_total, message_total, missile_total, obstacle_total, obstacle_graphic_total
Dim Shared As Integer particle_total, portal_total
Dim Shared As Integer sound_music_total, sound_music_current, sound_fire_repeat_delay

Dim Shared As option_type utility_menu_main, utility_menu_ingame, utility_menu_gamecomplete

Dim Shared As alien_type alien(1 To alien_max)
Dim Shared As beamup_type beamup(1 To beamup_max)
Dim Shared As bomb_type bomb(1 To bomb_max)
Dim Shared As bombglow_type bombglow(1 To bombglow_max)
Dim Shared As bonus_type bonus(1 To bonus_max)
Dim Shared As boss_type boss(1 To boss_max)
Dim Shared As bubble_type bubble(1 To bubble_max)
Dim Shared As bubblemaker_type bubblemaker(1 To bubblemaker_max)
Dim Shared As damage_type damage(1 To damage_max)
Dim Shared As flame_type flame(1 To flame_max)
Dim Shared As highscore_type highscore(1 To highscore_max)
Dim Shared As message_type message(1 To message_max)
Dim Shared As missile_type missile(1 To missile_max)
Dim Shared As obstacle_type obstacle(1 To obstacle_max)
Dim Shared As obstacle_graphic_type obstacle_graphic(1 To obstacle_graphic_max)
Dim Shared As particle_type particle(1 To particle_max)
Dim Shared As player_type player
Dim Shared As portal_type portal(1 To portal_max)
Dim Shared As fmusic_module Ptr sound_music(1 To sound_music_max)

Dim Shared As fb.image Ptr alien_graphic, background_graphic, beamup_graphic, bomb_graphic, bombglow_graphic
Dim Shared As fb.image Ptr bonus_graphic(1 To bonus_enum.total), boss_graphic, bubble_graphic, bubblemaker_graphic, damage_graphic
Dim Shared As fb.image Ptr flame_graphic, player_graphic, portal_graphic, game_graphic
Dim Shared As fb.image Ptr player_energy_graphic, player_missile_graphic, player_health_graphic, player_score_graphic

Dim Shared As fmusic_module Ptr sound_bonus, sound_explode, sound_fire, sound_hit

Dim Shared As game_type game
Dim Shared As progress_type progress

Declare Sub bombglow_add (Byval x As Integer, Byval y As Integer)
Declare Sub bonus_add (Byval x As Integer, Byval y As Integer, Byref title As String)
Declare Sub highscore_display
Declare Sub missile_add (Byval x As Integer, Byval y As Integer, Byref xv As Double)
Declare Sub particle_add (Byval x As Integer, Byval y As Integer)
Declare Sub sound_add_effect (Byval s As fmusic_module Ptr, Byval x As Integer)
Declare Sub sound_add_music (Byval s As Integer)

Sub utility_clear_buffer
  If Inkey > "" Or Multikey(&H48) Or Multikey(&H4D) Or Multikey(&H4B) Or Multikey(&H39) Then
    Do
      While Inkey > "" Or Multikey(&H48) Or Multikey(&H4D) Or Multikey(&H4B) Or Multikey(&H39): Sleep 50, 1: Wend
      Sleep 500, 1
    Loop Until Inkey = ""
  End If
End Sub

Sub utility_start
  With utility_menu_main
    .options(1) = "Continue Game"
    .options(2) = "New Game"
    .options(3) = "High Scores"
    .options(4) = "Quit"
    .total = 4
  End With
  
  With utility_menu_ingame
    .options(1) = "Continue Game"
    .options(2) = "Quit"
    .total = 2
  End With
  
  With utility_menu_gamecomplete
    .options(1) = "Game Complete!"
    .total = 1
  End With
End Sub

Function utility_collision (Byval i1 As fb.image Ptr, Byval x1 As Integer, Byval y1 As Integer, _
  Byval i2 As fb.image Ptr = 0, Byval x2 As Integer, Byval y2 As Integer) As Integer
  
  Const transparent = &HFFFF00FF
  
  Dim As Integer x, y, tx, ty, tx2, ty2
  
  x = x2 - x1
  y = y2 - y1
  
  'second image is a single point; see if it is on the image
  If i2 = 0 Then
    If x < 0 Or y < 0 Then Return false
    If x >= i1 -> Width Then Return false
    If y >= i1 -> height Then Return false
    Return Point2(x, y, i1) <> transparent
  End If
  
  'bounds checking
  If x > 0 Then
    If (i1 -> Width) <= x Then Return false
  Else
    If (i2 -> Width) <= -x Then Return false
  End If
  If y > 0 Then
    If (i1 -> height) <= y Then Return false
  Else
    If (i2 -> height) <= -y Then Return false
  End If
  
  For lx As Double = 0 To 1 Step .25
    For ly As Double = 0 To 1 Step .25
      'test a point from i1
      tx = ((i1 -> Width) - 1) * lx
      ty = ((i1 -> height) - 1) * ly
      
      If Point2(tx, ty, i1) <> transparent Then
        tx2 = tx - x
        ty2 = ty - y
        If tx2 >= 0 And tx2 < (i2 -> Width) Then
          If ty2 >= 0 And ty2 < (i2 -> height) Then
            If Point2(tx2, ty2, i2) <> transparent Then Return true
          End If
        End If
      End If
      
      'test a point from i2
      tx = ((i2 -> Width) - 1) * lx
      ty = ((i2 -> height) - 1) * ly
      
      If Point2(tx, ty, i2) <> transparent Then
        tx2 = tx + x
        ty2 = ty + y
        If tx2 >= 0 And tx2 < (i1 -> Width) Then
          If ty2 >= 0 And ty2 < (i1 -> height) Then
            If Point2(tx2, ty2, i1) <> transparent Then Return true
          End If
        End If
      End If
    Next y
  Next lx
  
  Return false
End Function

Sub utility_loadimage (Byref filename As String, Byref image As fb.image Ptr)
  Dim As Integer bwidth, bheight, ff = Freefile
  
  Open filename For Binary As #ff
  Get #ff, 19, bwidth
  Get #ff, 23, bheight
  Close #ff
  
  image = imagecreate(bwidth, bheight)
  Bload filename, image
End Sub

Sub alien_start
  utility_loadimage "data/gfx/misc/alien.bmp", alien_graphic
End Sub

Sub alien_reset
  alien_total = 0
End Sub

Sub alien_add (Byval x As Integer, Byval y As Integer)
  If alien_total = alien_max Then Exit Sub
  
  alien_total += 1
  With alien(alien_total)
    .yv = 2
    With .core
      .p.x = x
      .p.y = y
      .killme = false
    End With
  End With
End Sub

Sub alien_move
  Dim As Integer s
  
  For a As Integer = 1 To alien_total
    With alien(a)
      'adjust position and velocity
      .core.p.y += .yv
      If .core.p.y < 0 Then
        .core.p.y = 0
        .yv = -.yv
      End If
      If .core.p.y + (alien_graphic -> height) > screeny Then
        .core.p.y = screeny - (alien_graphic -> height)
        .yv = -.yv
      End If
      
      'hit bomb
      For b As Integer = 1 To bomb_total
        If utility_collision(alien_graphic, .core.p.x, .core.p.y, _
          bomb_graphic, bomb(b).core.p.x, bomb(b).core.p.y) Then
          
          bomb(b).core.killme = true
          particle_add bomb(b).core.p.x + (bombglow_graphic -> Width) Shr 1, bomb(b).core.p.y + (bombglow_graphic -> height) Shr 1
        End If
      Next a
      
      'fire
      If .core.p.x - game.cam < screenx Then
        If (game.frame Mod 12) = 0 Then
          s = Sgn(player.core.p.x - alien(a).core.p.x)
          missile_add .core.p.x + Iif(s = 1, (alien_graphic -> Width), 0) + 6 * s, .core.p.y + (alien_graphic -> height) Shr 1, s * 6
        End If
      End If
      
      'pre cleanup
      If .core.p.x + (alien_graphic -> Width) - 1 < game.cam Then .core.killme = true
      
      'leave bonus gem
      If .core.killme Then
        bonus_add .core.p.x, .core.p.y, "GEM"
      End If
    End With
  Next a
  
  cleanup(alien, alien_total)
End Sub

Sub alien_display
  For a As Integer = 1 To alien_total
    With alien(a)
      Put (.core.p.x - game.cam, .core.p.y), alien_graphic, masteralpha
    End With
  Next a
End Sub

Sub alien_finish
  imagedestroy(alien_graphic)
End Sub

Function utility_menu (Byref options As option_type, Byval usebackground As Integer = true) As Integer
  Dim As Integer selected
  Dim As String key, text
  
  utility_clear_buffer
  
  selected = 1
  Do
    Select Case key
    Case ""
    Case Chr(255, 72)
      If selected > 1 Then selected -= 1
    Case Chr(255, 80)
      If selected < options.total Then selected += 1
    Case Else
      If Val(key) > 0 And Val(key) <= options.total Then selected = Val(key)
    End Select
    
    Screenlock
    If usebackground Then
      Put (0, 0), background_graphic, menualpha
    Else
      Put (0, 0), game_graphic, menualpha
    End If
    Line (150, 50) - (screenx - 150, 400), &HFF000000, B
    Draw String (screenx / 2 - 44, 58), "- UnAlien -", &HFF000000
    With options
      For a As Integer = 1 To .total
        If selected = a Then text = Chr(1, 32) Else text = "  "
        text += .options(a)
        Draw String (158, 100 + a * 16), text, &HFF000000
      Next a
    End With
    Screenunlock
    
    Sleep 20, 1
    key = Inkey
  Loop Until key = Chr(13) Or key = Chr(27) Or key = " " Or selected = Val(key)
  Return selected
End Function

Sub background_start
  utility_loadimage "data/gfx/misc/background.bmp", background_graphic
End Sub

Sub background_display
  Static As Double pt, offset
  
  Dim As Double t = Timer
  
  If pt = 0 Then pt = Timer
  offset -= (t - pt) * player.v.x * 4
  If offset < 0 Then offset += background_graphic -> Width
  If offset > (background_graphic -> Width) Then offset = offset Mod (background_graphic -> Width)
  
  Put (offset, 0), background_graphic, alpha, 150 'masteralpha
  Put (offset - background_graphic -> Width, 0), background_graphic, backgroundalpha
  
  pt = t
End Sub

Sub background_finish
  imagedestroy(background_graphic)
End Sub

Sub beamup_start
  utility_loadimage "data/gfx/misc/beamup.bmp", beamup_graphic
End Sub

Sub beamup_reset
  beamup_total = 0
End Sub

Sub beamup_add (Byval x As Integer, Byval y As Integer)
  If beamup_total = beamup_max Then Exit Sub
  
  beamup_total += 1
  With beamup(beamup_total).core
    .p.x = x
    .p.y = y
    .killme = false
  End With
End Sub

Sub beamup_move
  cleanup_clip(beamup, beamup_total, beamup_graphic)
  cleanup(beamup, beamup_total)
End Sub

Sub beamup_display
  For a As Integer = 1 To beamup_total
    With beamup(a)
      Put (.core.p.x - game.cam, .core.p.y), beamup_graphic, masteralpha
    End With
  Next a
End Sub

Sub beamup_finish
  imagedestroy(beamup_graphic)
End Sub

Sub bomb_start
  utility_loadimage "data/gfx/misc/bomb.bmp", bomb_graphic
End Sub

Sub bomb_reset
  bomb_total = 0
End Sub

Sub bomb_add (Byval x As Integer, Byval y As Integer)
  If bomb_total = bomb_max Then Exit Sub
  
  bomb_total += 1
  With bomb(bomb_total).core
    .p.x = x
    .p.y = y
    .killme = false
  End With
End Sub

Sub bomb_move
  For a As Integer = 1 To bomb_total
    With bomb(a)
      If .core.killme Then
        bombglow_add .core.p.x + ((bomb_graphic -> Width) Shr 1) - ((bombglow_graphic -> Width) Shr 1), _
          .core.p.y + ((bomb_graphic -> height) Shr 1) - ((bombglow_graphic -> height) Shr 1)
      Elseif .core.p.x + (bomb_graphic -> Width) - 1 < game.cam Then
        .core.killme = true
      End If
    End With
  Next a
  
  cleanup(bomb, bomb_total)
End Sub

Sub bomb_display
  For a As Integer = 1 To bomb_total
    With bomb(a)
      Put (.core.p.x - game.cam, .core.p.y), bomb_graphic, masteralpha
    End With
  Next a
End Sub

Sub bomb_finish
  imagedestroy(bomb_graphic)
End Sub

Sub bombglow_start
  bombglow_graphic = imagecreate(320, 320)
  Circle bombglow_graphic, (160, 160), 160, &HFFFF0000,,, 1, F 'fills possible gaps
  For a As Integer = 1 To 160
    Circle bombglow_graphic, (160, 160), a, Rgb(255, a, 0),,, 1
  Next 
End Sub

Sub bombglow_reset
  bombglow_total = 0
End Sub

Sub bombglow_add (Byval x As Integer, Byval y As Integer)
  If bombglow_total = bombglow_max Then Exit Sub
  
  bombglow_total += 1
  With bombglow(bombglow_total)
    .ttl = 80
    .core.p.x = x
    .core.p.y = y
    .core.killme = false
    
    sound_add_effect sound_explode, .core.p.x + (bombglow_graphic -> Width) Shr 1
  End With
End Sub

Sub bombglow_move
  For a As Integer = 1 To bombglow_total
    With bombglow(a)
      .ttl -= 1
      If .ttl <= 0 Then .core.killme = true
      
      'explode aliens
      For b As Integer = 1 To alien_total
        If utility_collision(bombglow_graphic, .core.p.x, .core.p.y, _
          alien_graphic, alien(b).core.p.x, alien(b).core.p.y) Then
          
          alien(b).core.killme = true
          particle_add alien(b).core.p.x + (alien_graphic -> Width) Shr 1, alien(b).core.p.y + (alien_graphic -> height) Shr 1
        End If
      Next b
      
      'explode bombs
      For b As Integer = 1 To bomb_total
        If utility_collision(bombglow_graphic, .core.p.x, .core.p.y, _
          bomb_graphic, bomb(b).core.p.x, bomb(b).core.p.y) Then
          
          bomb(b).core.killme = true
          particle_add bomb(b).core.p.x + (bomb_graphic -> Width) Shr 1, bomb(b).core.p.y + (bomb_graphic -> height) Shr 1
        End If
      Next b
      
      'explode bubbles
      For b As Integer = 1 To bubble_total
        If utility_collision(bombglow_graphic, .core.p.x, .core.p.y, _
          bubble_graphic, bubble(b).core.p.x, bubble(b).core.p.y) Then
          
          bubble(b).core.killme = true
        End If
      Next b
      
      'drop obstacles
      For b As Integer = 1 To obstacle_total
        If utility_collision(bombglow_graphic, .core.p.x, .core.p.y, _
          obstacle_graphic(obstacle(b).index).image, obstacle(b).core.p.x, obstacle(b).core.p.y) Then
          
          obstacle(b).falling = true
        End If
      Next b
      
      'hit player
      If utility_collision(bombglow_graphic, .core.p.x, .core.p.y, _
        player_graphic, player.core.p.x, player.core.p.y) Then
        
        player.hit = true
      End If
    End With
  Next a
  
  cleanup(bombglow, bombglow_total)
End Sub

Sub bombglow_display
  For a As Integer = 1 To bombglow_total
    With bombglow(a)
      Put (.core.p.x - game.cam, .core.p.y), bombglow_graphic, alpha, 255 - .ttl * 3
    End With
  Next a
End Sub

Sub bombglow_finish
  imagedestroy(bombglow_graphic)
End Sub

Sub bonus_start
  utility_loadimage "data/gfx/bonus/energy.bmp", bonus_graphic(bonus_enum.energy)
  utility_loadimage "data/gfx/bonus/gem.bmp", bonus_graphic(bonus_enum.gem)
  utility_loadimage "data/gfx/bonus/health.bmp", bonus_graphic(bonus_enum.health)
  utility_loadimage "data/gfx/bonus/missile.bmp", bonus_graphic(bonus_enum.missile)
End Sub

Sub bonus_reset
  bonus_total = 0
End Sub

Sub bonus_add (Byval x As Integer, Byval y As Integer, Byref title As String)
  Dim As Integer bt
  
  If bonus_total = bonus_max Then Exit Sub
  
  Select Case title
  Case "ENERGY"
    bt = bonus_enum.energy
  Case "GEM"
    bt = bonus_enum.gem
  Case "HEALTH"
    bt = bonus_enum.health
  Case "MISSILE"
    bt = bonus_enum.missile
  End Select
  
  If bt = 0 Then Exit Sub
  
  bonus_total += 1
  With bonus(bonus_total)
    .btype = bt
    With .core
      .p.x = x
      .p.y = y
      .killme = false
    End With
  End With
End Sub

Sub bonus_move
  cleanup_clip(bonus, bonus_total, bonus_graphic(.btype))
  cleanup(bonus, bonus_total)
End Sub

Sub bonus_display
  For a As Integer = 1 To bonus_total
    With bonus(a)
      Put (.core.p.x - game.cam, .core.p.y), bonus_graphic(.btype), masteralpha
    End With
  Next a
End Sub

Sub bonus_finish
  For a As Integer = 1 To bonus_enum.total
    imagedestroy(bonus_graphic(a))
  Next a
End Sub

Sub boss_start
  utility_loadimage "data/gfx/misc/boss.bmp", boss_graphic
End Sub

Sub boss_reset
  boss_total = 0
End Sub

Sub boss_add (Byval x As Integer, Byval y As Integer, Byval hp As Integer)
  If boss_total = boss_max Then Exit Sub
  
  boss_total += 1
  With boss(boss_total)
    .hp = hp
    .yv = 0
    With .core
      .p.x = x
      .p.y = y
      .killme = false
    End With
  End With
End Sub

Sub boss_move
  Dim As Integer x, y
  
  For a As Integer = 1 To boss_total
    With boss(a)
      If .core.p.x - game.cam <= screenx - 1 Then
        'move x
        If .core.p.x + (boss_graphic -> Width) - game.cam < screenx * .9 Then
          .core.p.x += player.v.x
        End If
        
        'move y
        .yv += .1
        .core.p.y += .yv
        
        If .core.p.y < 0 Then
          .core.p.y = 0
          .yv = -.yv
        End If
        
        If .core.p.y + (boss_graphic -> height) > screeny Then
          .core.p.y = screeny - (boss_graphic -> height)
          .yv = -.yv
        End If
        
        'fire missiles
        If (game.frame Mod 8) = 0 Then
          missile_add .core.p.x - 16, .core.p.y + (boss_graphic -> height) Shr 1, -8
        End If
        
        'cleanup
        If .hp <= 0 Then
          x = .core.p.x + (boss_graphic -> Width) Shr 1
          y = .core.p.y + (boss_graphic -> height) Shr 1
          For d As Double = 0 To pi * 8 Step pi / 8
            bonus_add x + Cos(d) * d * 8, y + Sin(d) * d * 8, "GEM"
          Next d
          
          .core.killme = true
          sound_add_effect sound_explode, .core.p.x + (boss_graphic -> Width) Shr 1
        End If
      End If
    End With
  Next a
  
  cleanup(boss, boss_total)
End Sub

Sub boss_display
  Dim As Integer y
  
  For a As Integer = 1 To boss_total
    With boss(a)
      Put (.core.p.x - game.cam, .core.p.y), boss_graphic, masteralpha
      If .core.p.x - game.cam < screenx Then y += .hp
    End With
  Next a
  
  If y > 0 Then
    Line (screenx - 20, 0) - Step(9, y / 2), &HFF000000, BF
  End If
End Sub

Sub boss_finish
  imagedestroy(boss_graphic)
End Sub

Sub bubble_start
  utility_loadimage "data/gfx/misc/bubble.bmp", bubble_graphic
End Sub

Sub bubble_reset
  bubble_total = 0
End Sub

Sub bubble_add (Byval x As Integer, Byval y As Integer)
  If bubble_total = bubble_max Then Exit Sub
  
  bubble_total += 1
  With bubble(bubble_total)
    .v.x = -Rnd * 2
    .v.y = (Rnd - Rnd) * 2
    With .core
      .p.x = x
      .p.y = y
      .killme = false
    End With
  End With
End Sub

Sub bubble_move
  For a As Integer = 1 To bubble_total
    With bubble(a)
      .core.p.x += .v.x
      .core.p.y += .v.y
      
      'keep on screen
      If .core.p.y < 0 Then
        .core.p.y = 0
        .v.y = -.v.y
      End If
      
      If .core.p.y + (bubble_graphic -> height) > screeny Then
        .core.p.y = screeny - (bubble_graphic -> height)
        .v.y = -.v.y
      End If
      
      'stick to obstacles
      If .v.x <> 0 Then
        For b As Integer = 1 To obstacle_total
          If utility_collision(bubble_graphic, .core.p.x, .core.p.y, _
            obstacle_graphic(obstacle(b).index).image, obstacle(b).core.p.x, obstacle(b).core.p.y) Then
            
            .v.x = 0
            .v.y = 0
            Exit For
          End If
        Next b
      End If
      
      'stick to other bubbles (optimize this since it could loop 2 million times / sec)
      If .v.x = 0 Then
        For b As Integer = 1 To bubble_total
          If bubble(b).v.x = 0 Then
            If a <> b Then
              If Abs(.core.p.x - bubble(b).core.p.x) < 32 Then
                If utility_collision(bubble_graphic, .core.p.x, .core.p.y, _
                  bubble_graphic, bubble(b).core.p.x, bubble(b).core.p.y) Then
                  
                  .v.x = 0
                  .v.y = 0
                  Exit For
                End If
              End If
            End If
          End If
        Next b
      End If
      
      'hit player
      If utility_collision(bubble_graphic, .core.p.x, .core.p.y, _
        player_graphic, player.core.p.x, player.core.p.y) Then
        
        player.hit = true
      End If
      
      'clipping
      If .core.p.x + (bubble_graphic -> Width) - 1 < game.cam Then .core.killme = true
    End With
  Next a
  
  cleanup(bubble, bubble_total)
End Sub

Sub bubble_display
  For a As Integer = 1 To bubble_total
    With bubble(a)
      Put (.core.p.x - game.cam, .core.p.y), bubble_graphic, masteralpha
    End With
  Next a
End Sub

Sub bubble_finish
  imagedestroy(bubble_graphic)
End Sub

Sub bubblemaker_start
  utility_loadimage "data/gfx/misc/bubblemaker.bmp", bubblemaker_graphic
End Sub

Sub bubblemaker_reset
  bubblemaker_total = 0
End Sub

Sub bubblemaker_add (Byval x As Integer, Byval y As Integer)
  If bubblemaker_total = bubblemaker_max Then Exit Sub
  
  bubblemaker_total += 1
  With bubblemaker(bubblemaker_total).core
    .p.x = x
    .p.y = y
    .killme = false
  End With
End Sub

Sub bubblemaker_move
  For a As Integer = 1 To bubblemaker_total
    With bubblemaker(a)
      If (game.frame Mod 32) = 0 Then
        bubble_add (.core.p.x + (bubblemaker_graphic -> Width - bubble_graphic -> Width) Shr 1, _
          .core.p.y + (bubblemaker_graphic -> height - bubble_graphic -> height) Shr 1)
      End If
    End With
  Next a
  
  cleanup_clip(bubblemaker, bubblemaker_total, bubblemaker_graphic)
  cleanup(bubblemaker, bubblemaker_total)
End Sub

Sub bubblemaker_display
  For a As Integer = 1 To bubblemaker_total
    With bubblemaker(a)
      Put (.core.p.x - game.cam, .core.p.y), bubblemaker_graphic, masteralpha
    End With
  Next a
End Sub

Sub bubblemaker_finish
  imagedestroy(bubblemaker_graphic)
End Sub

Sub damage_start
  utility_loadimage "data/gfx/misc/damage.bmp", damage_graphic
End Sub

Sub damage_reset
  damage_total = 0
End Sub

Sub damage_add (Byval x As Integer, Byval y As Integer)
  If damage_total = damage_max Then Exit Sub
  
  damage_total += 1
  With damage(damage_total)
    .ttl = 120
    With .core
      .p.x = x
      .p.y = y
      .killme = false
    End With
    
    sound_add_effect sound_hit, .core.p.x + (damage_graphic -> Width) Shr 1
  End With
End Sub

Sub damage_move
  For a As Integer = 1 To damage_total
    With damage(a)
      .ttl -= 1
      If .core.p.x + (damage_graphic -> Width) - game.cam < 1 Or .ttl <= 0 Then .core.killme = true
    End With
  Next a
  
  cleanup(damage, damage_total)
End Sub

Sub damage_display
  For a As Integer = 1 To damage_total
    With damage(a)
      Put (.core.p.x - game.cam, .core.p.y), damage_graphic, alpha, .ttl * 2
    End With
  Next a
End Sub

Sub damage_finish
  imagedestroy(damage_graphic)
End Sub

Sub flame_start
  utility_loadimage "data/gfx/misc/flame.bmp", flame_graphic
End Sub

Sub flame_reset
  flame_total = 0
End Sub

Sub flame_add (Byval x As Integer, Byval y As Integer)
  If flame_total = flame_max Then Exit Sub
  
  flame_total += 1
  With flame(flame_total).core
    .p.x = x
    .p.y = y
    .killme = false
  End With
End Sub

Sub flame_move
  cleanup_clip(flame, flame_total, flame_graphic)
  cleanup(flame, flame_total)
End Sub

Sub flame_display
  For a As Integer = 1 To flame_total
    With flame(a)
      Put (.core.p.x - game.cam, .core.p.y), flame_graphic, masteralpha
    End With
  Next a
End Sub

Sub flame_finish
  imagedestroy(flame_graphic)
End Sub

Sub highscore_start
  Dim As Integer a
  
  Open "data/highscores.dat" For Input As #1
  While Not Eof(1)
    a += 1
    With highscore(a)
      Line Input #1, .player
      Input #1, .score
    End With
  Wend
  Close #1
End Sub

Sub highscore_add (Byval score As Integer)
  Dim As Integer index
  Dim As String key, player
  
  If score <= highscore(highscore_max).score Then
    highscore_display
    Exit Sub
  End If
  
  utility_clear_buffer
  
  Do
    Select Case key
    Case Chr(8)
      If Len(player) > 0 Then player = Left(player, Len(player) - 1)
    Case Else
      If Len(key) = 1 And Len(player) < 16 Then player += key
    End Select
    
    Screenlock
    Put (0, 0), background_graphic, menualpha
    Line (150, 50) - (screenx - 150, 400), &HFF000000, B
    Draw String (screenx / 2 - 56, 58), "- High Score -", &HFF000000
    Draw String (158, 116), "Player: " & player, &HFF000000
    Draw String (158, 132), "Score: " & score, &HFF000000
    Screenunlock
    
    Sleep 20, 1
    key = Inkey
  Loop Until key = Chr(13) Or key = Chr(27)
  
  For i As Integer = 1 To highscore_max
    If highscore(i).score < score Then
      index = i
      Exit For
    End If
  Next i
  
  For i As Integer = highscore_max - 1 To index Step -1
    Swap highscore(i), highscore(i + 1)
  Next i
  
  With highscore(index)
    .player = player
    .score = score
  End With
  
  highscore_display
End Sub

Sub highscore_display
  Dim As String key
  
  utility_clear_buffer
  
  Do
    Screenlock
    Put (0, 0), background_graphic, menualpha
    Line (150, 50) - (screenx - 150, 400), &HFF000000, B
    Draw String (screenx / 2 - 56, 58), "- High Score -", &HFF000000
    For i As Integer = 1 To highscore_max
      With highscore(i)
        Draw String (158, 100 + i * 16), Left("[" & .score & "]     ", 8) & .player, &HFF000000
      End With
    Next i
    Screenunlock
    
    Sleep 20, 1
    key = Inkey
  Loop Until key = Chr(13) Or key = Chr(27) Or key = " "
End Sub

Sub highscore_finish
  Open "data/highscores.dat" For Output As #1
  For i As Integer = 1 To highscore_max
    With highscore(i)
      Print #1, .player
      Print #1, .score
    End With
  Next i
  Close #1
End Sub

Sub message_reset
  message_total = 0
End Sub

Sub message_add (Byval x As Integer, Byval y As Integer, Byref text As String)
  If message_total = message_max Then Exit Sub
  
  message_total += 1
  With message(message_total)
    .text = text
    With .core
      .p.x = x
      .p.y = y
      .killme = false
    End With
  End With
End Sub

Sub message_move
  For a As Integer = 1 To message_total
    With message(a)
      If .core.p.x + Len(.text) * 8 - game.cam - 1 > 0 And .core.p.x - game.cam < screenx - 1 Then .core.p.x += player.v.x / 2
      If .core.p.x + Len(.text) * 8 - 1 < game.cam Then .core.killme = true
    End With
  Next a
  
  cleanup(message, message_total)
End Sub

Sub message_display
  For a As Integer = 1 To message_total
    With message(a)
      Draw String (.core.p.x - game.cam, .core.p.y), .text, &HFF000000
    End With
  Next a
End Sub

Sub missile_reset
  missile_total = 0
End Sub

Sub missile_add (Byval x As Integer, Byval y As Integer, Byref xv As Double)
  If missile_total = missile_max Or xv = 0 Then Exit Sub
  
  missile_total += 1
  With missile(missile_total)
    .xv = xv
    .core.p.x = x
    .core.p.y = y
    .core.killme = false
  End With
End Sub

Sub missile_move
  For a As Integer = 1 To missile_total
    With missile(a)
      .core.p.x += .xv
      
      'collide with alien
      For b As Integer = 1 To alien_total
        If utility_collision(alien_graphic, alien(b).core.p.x, alien(b).core.p.y,, .core.p.x, .core.p.y) Then
          alien(b).core.killme = true
          .core.killme = true
          particle_add .core.p.x, .core.p.y
        End If
      Next b
      
      'collide with bomb
      For b As Integer = 1 To bomb_total
        If utility_collision(bomb_graphic, bomb(b).core.p.x, bomb(b).core.p.y,, .core.p.x, .core.p.y) Then
          
          bomb(b).core.killme = true
          .core.killme = true
          particle_add .core.p.x, .core.p.y
        End If
      Next b
      
      'collide with boss
      For b As Integer = 1 To boss_total
        If utility_collision(boss_graphic, boss(b).core.p.x, boss(b).core.p.y,, _
          .core.p.x, .core.p.y) Then
          
          boss(b).hp -= 1
          .core.killme = true
          particle_add .core.p.x, .core.p.y
        End If
      Next b
      
      'collide with bubble
      For b As Integer = 1 To bubble_total
        If utility_collision(bubble_graphic, bubble(b).core.p.x, bubble(b).core.p.y,, _
          .core.p.x, .core.p.y) Then
          
          bubble(b).core.killme = true
          .core.killme = true
          particle_add .core.p.x, .core.p.y
        End If
      Next b
      
      'collide with obstacle
      For b As Integer = 1 To obstacle_total
        If utility_collision(obstacle_graphic(obstacle(b).index).image, obstacle(b).core.p.x, obstacle(b).core.p.y,, _
          .core.p.x, .core.p.y) Then
          
          .core.killme = true
          damage_add .core.p.x, .core.p.y - (damage_graphic -> height) Shr 1
        End If
      Next b
      
      'collide with player
      If utility_collision(player_graphic, player.core.p.x, player.core.p.y,, .core.p.x, .core.p.y) Then
        player.hit = true
        .core.killme = true
      End If
      
      If .core.p.x - game.cam < 0 Or .core.p.x - game.cam > screenx - 1 Then .core.killme = true
    End With
  Next a
  
  cleanup(missile, missile_total)
End Sub

Sub missile_display
  For a As Integer = 1 To missile_total
    With missile(a)
      Line (.core.p.x - game.cam, .core.p.y) - Step(-.xv, 0), &HFF000000
    End With
  Next a
End Sub

Sub obstacle_start
  Dim As Integer bwidth, bheight
  Dim As String l
  
  Open "data/gfx/obstacles/list.dat" For Input As #1
  While Not Eof(1)
    obstacle_graphic_total += 1
    
    Line Input #1, l
    obstacle_graphic(obstacle_graphic_total).title = Ucase(l)
    
    l = "data/gfx/obstacles/" & l & ".bmp"
    
    utility_loadimage l, obstacle_graphic(obstacle_graphic_total).image
  Wend
  Close #1
End Sub

Sub obstacle_reset
  obstacle_total = 0
End Sub

Sub obstacle_add (Byval x As Integer, Byval y As Integer, Byref title As String)
  Dim As Integer a
  
  If obstacle_total = obstacle_max Then Exit Sub
  
  For i As Integer = 1 To obstacle_graphic_total
    If obstacle_graphic(i).title = title Then a = i
  Next i
  
  If a = 0 Then Exit Sub
  
  obstacle_total += 1
  With obstacle(obstacle_total)
    .index = a
    .falling = false
    .yv = 0
    .core.p.x = x
    .core.p.y = y
    .core.killme = false
  End With
End Sub

Sub obstacle_move
  For a As Integer = 1 To obstacle_total
    With obstacle(a)
      If .falling Then
        .yv += .4
        .core.p.y += .yv
      End If
      
      If .core.p.y > screeny - 1 Or .core.p.x + (obstacle_graphic(.index).image -> Width) - 1 < game.cam Then .core.killme = true
    End With
  Next a
  
  cleanup(obstacle, obstacle_total)
End Sub

Sub obstacle_display
  For i As Integer = 1 To obstacle_total
    With obstacle(i)
      Put (.core.p.x - game.cam, .core.p.y), obstacle_graphic(.index).image, masteralpha
    End With
  Next i
End Sub

Sub obstacle_finish
  For a As Integer = 1 To obstacle_graphic_total
    imagedestroy(obstacle_graphic(a).image)
  Next a
End Sub

Sub particle_reset
  particle_total = 0
End Sub

Sub particle_add (Byval x As Integer, Byval y As Integer)
  If particle_total = particle_max Then Exit Sub
  
  particle_total += 1
  
  With particle(particle_total)
    .distance = 0
    .ttl = 100
    .core.p.x = x
    .core.p.y = y
    .core.killme = false
    
    sound_add_effect sound_hit, x
  End With
End Sub

Sub particle_move
  For a As Integer = 1 To particle_total
    With particle(a)
      .distance += .speed
      .ttl -= 1
      If .ttl <= 0 Then .core.killme = true
    End With
  Next a
  
  cleanup(particle, particle_total)
End Sub

Sub particle_display
  Dim As Integer a
  Dim As Double d
  
  For a = 1 To particle_total
    With particle(a)
      For d = 0 To pi * 2 Step pi / 12
        Circle (.core.p.x + Cos(d) * .distance - game.cam, .core.p.y + Sin(d) * .distance), 2, &HFF000000,,, 1, F
      Next d
    End With
  Next a
End Sub

Sub player_start
  utility_loadimage "data/gfx/misc/player.bmp", player_graphic
  
  player_energy_graphic = imagecreate(10, screeny, &HFFFF0000)
  player_missile_graphic = imagecreate(10, screeny, &HFFFFFFFF)
  player_health_graphic = imagecreate(10, screeny, &HFF88FF88)
  player_score_graphic = imagecreate(10, screeny, &HFF8888FF)
  
  Line player_energy_graphic, (0, -1) - (9, screeny - 1), &HFF000000, B
  Line player_missile_graphic, (0, -1) - (9, screeny - 1), &HFF000000, B
  Line player_health_graphic, (0, -1) - (9, screeny - 1), &HFF000000, B
  Line player_score_graphic, (0, -1) - (9, screeny - 1), &HFF000000, B
End Sub

Sub player_reset
  With player
    .v.x = 0
    .v.y = 0
    .bonus_energy = 5000
    .bonus_missile = 150
    .bonus_health = 8
    .bonus_score = 0
    For a As Integer = 1 To .history_max
      .history(a) = 0
    Next a
    .hit = false
    .core.p.x = 0
    .core.p.y = 0
  End With
End Sub

Sub player_move
  Static As Integer frames_since_hit 'set when player hits obstacle
  
  With player
    'manage history trail
    If (game.frame Mod 4) = 0 Then
      For a As Integer = .history_max To 2 Step -1
        Swap .history(a), .history(a - 1)
      Next a
      .history(1) = .core.p.y
    End If
    
    'update velocity
    .v.x *= .70
    .v.x += (1 + Abs(Multikey(fb.sc_right))) * .6
    If Multikey(fb.sc_up) And .bonus_energy > 0 Then
      .bonus_energy -= 1
      .v.y -= .2
    Else
      .v.y += .2
    End If
    For a As Integer = 1 To beamup_total
      If utility_collision(player_graphic, .core.p.x, .core.p.y, _
        beamup_graphic, beamup(a).core.p.x, beamup(a).core.p.y) Then
        
        .v.y -= .2
      End If
    Next a
    
    'update position
    .core.p.x += .v.x
    .core.p.y += .v.y
  
    'check collision with screen borders and obstacles
    If .core.p.y < 0 Then
      .hit = true
    Elseif .core.p.y + (player_graphic -> height) > screeny Then
      .hit = true
    Else
      For a As Integer = 1 To obstacle_total
        If utility_collision(player_graphic, .core.p.x, .core.p.y, _
          obstacle_graphic(obstacle(a).index).image, obstacle(a).core.p.x, obstacle(a).core.p.y) Then
          
          .hit = true
          Exit For
        End If
      Next a
    End If
    
    'lose health from hit
    If frames_since_hit < 100 Then
      frames_since_hit += 1
    Elseif .hit Then
      'add particles
      If .hit Then
        particle_add .core.p.x + (player_graphic -> Width), .core.p.y + (player_graphic -> height) Shr 1
      End If
      
      .bonus_health -= 1
      If .bonus_health <= 0 Then game.lost = true
      frames_since_hit = 0
    End If
    .hit = false
    
    'keep onscreen
    If .core.p.y < 0 Then
      .core.p.y = 0
      .v.y = .1
    End If
    If .core.p.y + (player_graphic -> height) > screeny Then
      .core.p.y = screeny - (player_graphic -> height)
      .v.y = -.1
    End If
    
    'hit bomb
    For a As Integer = 1 To bomb_total
      If utility_collision(player_graphic, .core.p.x, .core.p.y, _
        bomb_graphic, bomb(a).core.p.x, bomb(a).core.p.y) Then
        
        bomb(a).core.killme = true
        particle_add bomb(a).core.p.x + (bomb_graphic -> Width) Shr 1, bomb(a).core.p.y + (bomb_graphic -> height) Shr 1
      End If
    Next a
    
    'collect bonus
    For a As Integer = 1 To bonus_total
      If utility_collision(player_graphic, .core.p.x, .core.p.y, _
        bonus_graphic(bonus(a).btype), bonus(a).core.p.x, bonus(a).core.p.y) Then
        
        Select Case bonus(a).btype
        Case bonus_enum.energy
          .bonus_energy += 600
        Case bonus_enum.gem
          .bonus_score += 1
        Case bonus_enum.health
          .bonus_health += 1
        Case bonus_enum.missile
          .bonus_missile += 100
        End Select
        
        bonus(a).core.killme = true
        sound_add_effect sound_bonus, .core.p.x
      End If
    Next a
    
    'hit flame (lose energy)
    If .bonus_energy > 0 Then
      For a As Integer = 1 To flame_total
        If utility_collision(player_graphic, .core.p.x, .core.p.y, _
          flame_graphic, flame(a).core.p.x, flame(a).core.p.y) Then
          
          .bonus_energy -= 20
          Exit For
        End If
      Next a
    End If
    
    'hit portal (win game)
    For a As Integer = 1 To portal_total
      If utility_collision(player_graphic, .core.p.x, .core.p.y, _
        portal_graphic, portal(a).core.p.x, portal(a).core.p.y) Then
        
        game.won = true
        Exit For
      End If
    Next a
    
    'fire missiles
    If Multikey(fb.sc_space) And (game.frame Mod 4) = 0 And .bonus_missile > 0 Then
      .bonus_missile -= 1
      missile_add .core.p.x + (player_graphic -> Width) + .v.x * 2, .core.p.y + (player_graphic -> height) Shr 1, .v.x * 8
      If game.frame - sound_fire_repeat_delay > 12 Then
        sound_fire_repeat_delay = game.frame
        sound_add_effect sound_fire, .core.p.x
      End If
    End If
  End With
End Sub

Sub player_display
  Dim As Integer y
  
  With player
    'history trail
    For a As Integer = 1 To .history_max
      Put (.core.p.x - game.cam - a * 2 * .v.x, .history(a)), player_graphic, alpha, 100 - a * 8
    Next a
    
    'stats
    If .bonus_energy > 0 Then
      y = .bonus_energy / 60 - screeny
      If y > 0 Then y = 0
      Put (8, y), player_energy_graphic, masteralpha
    End If
    If .bonus_health > 0 Then
      y = .bonus_health * 10 - screeny
      If y > 0 Then y = 0
      Put (20, y), player_health_graphic, masteralpha
    End If
    If .bonus_missile > 0 Then
      y = .bonus_missile / 10 - screeny
      If y > 0 Then y = 0
      Put (32, y), player_missile_graphic, masteralpha
    End If
    If .bonus_score > 0 Then
      y = .bonus_score * 10 - screeny
      If y > 0 Then y = 0
      Put (44, y), player_score_graphic, masteralpha
    End If
    
    'player
    Put (.core.p.x - game.cam, .core.p.y), player_graphic, masteralpha
  End With
End Sub

Sub player_finish
  imagedestroy(player_graphic)
End Sub

Sub portal_start
  utility_loadimage "data/gfx/misc/portal.bmp", portal_graphic
End Sub

Sub portal_reset
  portal_total = 0
End Sub

Sub portal_add (Byval x As Integer, Byval y As Integer)
  If portal_total = portal_max Then Exit Sub
  
  portal_total += 1
  With portal(portal_total).core
    .p.x = x
    .p.y = y
    .killme = false
  End With
End Sub

Sub portal_move
  If portal_total = 0 And boss_total = 0 And obstacle_total = 0 Then portal_add game.cam + 1000, 120
  
  cleanup_clip(portal, portal_total, portal_graphic)
  cleanup(portal, portal_total)
End Sub

Sub portal_display
  For a As Integer = 1 To portal_total
    With portal(a)
      Put (.core.p.x - game.cam, .core.p.y), portal_graphic, masteralpha
    End With
  Next a
End Sub

Sub portal_finish
  imagedestroy(portal_graphic)
End Sub

Sub sound_start
  Dim As String l
  
  If fsound_init(44100, 32, 0) = false Then System
  
  'load sound effects here
  sound_bonus = fsound_sample_load(fsound_free, "data/sound/fx/bonus.mp3", 0, 0, 0)
  sound_explode = fsound_sample_load(fsound_free, "data/sound/fx/explode.mp3", 0, 0, 0)
  sound_fire = fsound_sample_load(fsound_free, "data/sound/fx/fire.mp3", 0, 0, 0)
  sound_hit = fsound_sample_load(fsound_free, "data/sound/fx/hit.mp3", 0, 0, 0)
  
  Open "data/sound/music/list.dat" For Input As #1
  While Not Eof(1)
    Line Input #1, l
    sound_music_total += 1
    sound_music(sound_music_total) = fmusic_loadsong("data/sound/music/" & l)
  Wend
  Close #1
End Sub

Sub sound_reset
  sound_fire_repeat_delay = 0
End Sub

Sub sound_add_effect (Byval s As fmusic_module Ptr, Byval x As Integer)
  Dim As Integer c
  
  If x - game.cam < -100 Or x - game.cam > screenx + 99 Then Exit Sub
  
  c = fsound_playsound(fsound_free, s)
  If c Then fsound_setvolume(c, 256)
End Sub

Sub sound_add_music (Byval s As Integer)
  If fmusic_isplaying(sound_music(s)) Then Exit Sub 'don't restart song if it is already playing

  sound_music_current = s
  fmusic_stopallsongs
  fmusic_playsong(sound_music(sound_music_current))
  fmusic_setmastervolume(sound_music(sound_music_current), 256)
End Sub

Sub sound_move
  Dim As Integer s = Int(Rnd * sound_music_total + 1)
  
  'keep the music alive
  If fmusic_isfinished(sound_music(sound_music_current)) Or Multikey(fb.sc_0) Then
    Locate 5: ? s
    If Multikey(fb.sc_0) Then Sleep 2000, 1
    sound_add_music s
  End If
End Sub

Sub sound_finish
  fmusic_stopallsongs
  fsound_close
End Sub

Sub game_start
  Screenres screenx, screeny, 32
  game_graphic = imagecreate(screenx, screeny) 'for temporary storage
  
  alien_start
  background_start
  utility_start
  beamup_start
  bomb_start
  bombglow_start
  bonus_start
  boss_start
  bubble_start
  bubblemaker_start
  damage_start
  flame_start
  highscore_start
  obstacle_start
  player_start
  portal_start
  sound_start
  
  Open "data/progress.dat" For Input As #1
  With progress
    Input #1, .level
    Input #1, .score
    If .level = 0 Then .level = 1
  End With
  Close #1
End Sub

Sub game_reset
  Dim As Integer position, a, c1i
  Dim As String l, c0, c1, c2
  
  alien_reset
  beamup_reset
  bomb_reset
  bombglow_reset
  bonus_reset
  boss_reset
  bubble_reset
  bubblemaker_reset
  damage_reset
  flame_reset
  message_reset
  missile_reset
  obstacle_reset
  particle_reset
  player_reset
  portal_reset
  sound_reset
  
  With game
    .quit = false
    .won = false
    .lost = false
    .t = 0
    .frame = 0
    .cam = 0
    .key = ""
  End With
  
  'parse level
  Open "data/levels/" & progress.level & ".dat" For Input As #1
  While Not Eof(1)
    Line Input #1, l
    If Len(l) = 0 Then l = "SPACE: 40"
    l = Trim(Ucase (l))
    a = Instr(l, ":")
    
    If a > 0 Then
      c0 = Left(l, a - 1)
      c1 = Right(l, Len(l) - a)
      If Instr(c1, ":") > 0 Then
        a = Instr(c1, ":")
        c2 = Right(c1, Len(c1) - a)
        c1 = Left(c1, a - 1)
      End If
      c0 = Trim(c0)
      c1 = Trim(c1)
      c2 = Trim(c2)
      c1i = Val(c1) 'first argument is usually (always) a number
      
      Select Case c0
      Case "ALIEN"
        alien_add position, c1i
      Case "BEAMUP"
        beamup_add position, c1i
      Case "BOMB"
        bomb_add position, c1i
      Case "BONUS"
        bonus_add position, c1i, c2
      Case "BOSS"
        boss_add position, c1i, Val(c2)
      Case "BMAKER"
        bubblemaker_add position, c1i
      Case "FLAME"
        flame_add position, c1i
      Case "MESSAGE"
        message_add position, c1i, c2
      Case "OBSTACLE"
        obstacle_add position, c1i, c2
      Case "PORTAL"
        portal_add position, c1i
      Case "SPACE"
        position += c1i
      End Select
    End If
  Wend
  Close #1
End Sub

Sub game_move
  game.frame += 1
  
  alien_move
  beamup_move
  bomb_move
  bombglow_move
  bonus_move
  boss_move
  bubble_move
  bubblemaker_move
  damage_move
  flame_move
  message_move
  missile_move
  obstacle_move
  particle_move
  player_move
  portal_move
  sound_move
  
  game.cam = player.core.p.x - screenx / 6
End Sub

Sub game_display
  Screenlock
  background_display
  
  bombglow_display
  
  beamup_display
  bubble_display
  flame_display
  portal_display
  
  bubblemaker_display
  obstacle_display
  bomb_display
  
  bonus_display
  
  alien_display
  
  boss_display
  missile_display
  player_display
  
  damage_display
  particle_display
  
  message_display
  Screenunlock
End Sub

Sub game_over
  Dim As Integer c
  Dim As String s
  
  sound_add_effect sound_explode, player.core.p.x
  
  With game
    If .quit Then Exit Sub 'no progress change when quit (so the game can be continued by restarting the level)
    
    game_display
    If .lost Then
      s = "Game Over!"
    Else
      s = "Level Complete! Gems + Health: " & (player.bonus_score + player.bonus_health)
    End If
    Line (screenx / 2 - Len(s) * 4 - 8, screeny * .4 - 4) - Step(Len(s) * 8 + 16, 16), &HFFFFFFFF, bf
    Draw String (screenx / 2 - Len(s) * 4, screeny * .4), s, &HFF000000
    
    For x As Integer = 0 To screenx - 1
      For y As Integer = 0 To screeny - 1
        c = Point(x, y)
        c = ((c And &HFF0000) Shr 16) + ((c And &HFF00) Shr 8) + (c And &HFF)
        c = Int(c / 3)
        c = Rgb(c, c, c)
        Pset game_graphic, (x, y), c
      Next y
    Next x
    
    For a As Integer = 1 To 20
      Put (0, 0), game_graphic, alpha, 40
      Sleep 200, 1
    Next a
    
    If .lost Then
      highscore_add progress.score + player.bonus_score + player.bonus_health
      progress.score = 0 'when lose, start a new game, but at the same level
      Exit Sub
    End If
  End With
  
  'else, level complete
  With progress
    If .level = game.level_max Then
      utility_menu(utility_menu_gamecomplete)
      highscore_add .score + player.bonus_score + player.bonus_health + 50
      .level = 1
      .score = 0
    Else
      'go to next level
      .level += 1
      .score += player.bonus_score + player.bonus_health + 10
    End If
  End With
End Sub

Sub game_play
  Dim As Double t, st
  
  game_reset
  st = Timer 'for debugging > calculate FPS
  Do
    t = Timer
    
    game.key = Inkey
    If game.key = Chr(27) Then
      Get (0, 0) - (screenx - 1, screeny - 1), game_graphic
      Select Case utility_menu(utility_menu_ingame, false)
      Case 2
        game.quit = true
      End Select
    End If
    
    game_move
    
    game_display
    
    t = 25 + (t - Timer) * 1000
    If t > 0 Then Sleep t
  Loop Until game.quit Or game.won Or game.lost
  
  game_over
End Sub

Sub game_finish
  imagedestroy(game_graphic)
  
  alien_finish
  background_finish
  beamup_finish
  bomb_finish
  bombglow_finish
  bonus_finish
  boss_finish
  bubble_finish
  bubblemaker_finish
  damage_finish
  flame_finish
  highscore_finish
  obstacle_finish
  player_finish
  portal_finish
  sound_finish
  
  Open "data/progress.dat" For Output As #1
  With progress
    Print #1, .level
    Print #1, .score
  End With
  Close #1
End Sub

Dim As Integer quit

game_start
sound_add_music 1
Do
  utility_menu_main.options(1) = "Continue Game (Level: " & progress.level & " Score: " & progress.score & ")"
  
  Select Case utility_menu(utility_menu_main)
  Case 1
    game_play
  Case 2
    With progress
      'add high score for current game before terminating
      If .score > 0 Then
        highscore_add .score
      End If
      
      'reset progress
      .level = 1
      .score = 0
    End With
    game_play
  Case 3
    highscore_display
  Case 4
    quit = true
  End Select
Loop Until quit
game_finish
